<div
  class="full-width flex-row step-list-element container-border"
  [attr.data-test-test-step-id]="keywordStep.id"
  [attr.data-test-element-id]="'keyword-test-step'"
  [sqtmCoreDraggableListItem]="keywordStep.id"
  [class.border-selected]="keywordStep.selected && !keywordStep.draggingStep"
  [class.placeholder]="showPlaceHolder(keywordStep)"
>
  <div class="dnd-handler-wrapper flex-fixed-size">
    <div class="dnd-handler" sqtmCoreDraggableItemHandler></div>
  </div>
  <div class="flex-row index-column flex-fixed-size m-l-5">
    @if (editable) {
      <div class="arrow arrow-sup" (click)="moveStepUp(keywordStep)">
        <i
          nz-icon
          nzType="double-right"
          nzTheme="outline"
          class="arrow-sup-icon"
        ></i>
      </div>
    }
    <div
      class="index-typography"
      [class.selected]="keywordStep.selected && !keywordStep.draggingStep"
      (click)="selectStep($event, keywordStep.id)"
    >
      {{ keywordStep.stepOrder + 1 }}
    </div>
    @if (editable) {
      <div class="arrow arrow-down" (click)="moveStepDown(keywordStep)">
        <i
          nz-icon
          nzType="double-right"
          nzTheme="outline"
          class="arrow-down-icon"
        ></i>
      </div>
    }
  </div>
  <div class="full-width m-l-10 flex" style="align-items: center">
    @if (!showPlaceHolder(keywordStep)) {
      <div class="keyword-step-main-grid">
        <sqtm-core-editable-select-field
          style="text-align: right"
          [layout]="'no-buttons'"
          [options]="keywords"
          [value]="keywordStep.keyword"
          (confirmEvent)="changeKeyword($event)"
          [editable]="editable"
          [attr.data-test-field-id]="'keyword'"
        >
        </sqtm-core-editable-select-field>
        <sqtm-core-editable-action-text-field
          [displayValue]="keywordStep.styledAction"
          [value]="keywordStep.action"
          [options]="matchingActionWords"
          [autocompleteActive]="autocompleteActive"
          [editable]="editable"
          [layout]="'compact'"
          [attr.data-test-field-id]="'action'"
          (confirmEvent)="handleChangeAction($event)"
          (inputValueChanged)="getMatchingActionWord($event)"
          style="overflow: hidden"
        >
        </sqtm-core-editable-action-text-field>
        <div
          class="flex-fixed-size"
          [attr.data-test-element-id]="'button-area'"
        >
          <div
            class="action-buttons-wrapper step-list-element-buttons full-width"
          >
            <div class="action-buttons flex-row full-width">
              <i
                class="m-r-5 tree-icon-size current-workspace-button"
                nz-icon
                nzType="sqtm-core-generic:copy"
                nzTheme="outline"
                (click)="copyStep(keywordStep)"
                nz-tooltip
                [nzTooltipTitle]="
                  'sqtm-core.test-case-workspace.test-steps.button.copy'
                    | translate
                "
                [attr.data-test-button-id]="'copy'"
              ></i>
              @if (editable) {
                <sqtm-core-toggle-icon
                  class="m-r-5 tree-icon-size current-workspace-button"
                  [active]="hasCopiedKeywords$ | async"
                  (clickedInActiveMode)="pasteStep(keywordStep)"
                >
                  <i
                    class="tree-icon-size"
                    nz-icon
                    nzType="sqtm-core-generic:paste"
                    nzTheme="fill"
                    nz-tooltip
                    [nzTooltipTitle]="
                      'sqtm-core.generic.label.paste' | translate
                    "
                    [attr.data-test-button-id]="'paste'"
                  ></i>
                </sqtm-core-toggle-icon>
              }
              @if (editable) {
                <i
                  class="m-r-5 tree-icon-size current-workspace-button"
                  nz-icon
                  nzType="sqtm-core-generic:delete"
                  nzTheme="outline"
                  nz-tooltip
                  [nzTooltipTitle]="
                    'sqtm-core.entity.test-step.delete-multiple' | translate
                  "
                  [nzTooltipPlacement]="'topRight'"
                  (click)="deleteStep()"
                  [attr.data-test-button-id]="'delete'"
                ></i>
              }
              <i
                class="m-r-5 tree-icon-size current-workspace-button"
                nz-icon
                nzType="sqtm-core-generic:more"
                nzTheme="outline"
                nz-dropdown
                [nzDropdownMenu]="menu"
                [attr.data-test-button-id]="'more'"
              ></i>
            </div>
          </div>
        </div>
        @if (displaySection(DATATABLE)) {
          <div class="datatable-section step-section">
            <div>
              <span class="header-color">{{
                'sqtm-core.entity.test-step.datatable.label' | translate
              }}</span>
              @if (editable) {
                <i
                  class="m-l-5 sub-section-icon"
                  [attr.data-test-button-id]="'delete'"
                  [class.active]="!isEditingSectionField(DATATABLE)"
                  nz-icon
                  nzType="sqtm-core-generic:delete"
                  nzTheme="outline"
                  (click)="deleteSection(DATATABLE)"
                ></i>
              }
            </div>
            <sqtm-core-editable-text-area-field
              #datatableTextArea
              [attr.data-test-field-id]="DATATABLE"
              [value]="keywordStep.datatable"
              [monospaceFont]="true"
              (cancelEvent)="handleCancelSection(DATATABLE)"
              (confirmEvent)="changeSectionValue(DATATABLE, $event)"
            >
            </sqtm-core-editable-text-area-field>
          </div>
        }
        @if (displaySection(DOCSTRING)) {
          <div class="docstring-section step-section">
            <div>
              <span class="header-color">{{
                'sqtm-core.entity.test-step.docstring.label' | translate
              }}</span>
              @if (editable) {
                <i
                  class="m-l-5 sub-section-icon"
                  [attr.data-test-button-id]="'delete'"
                  [class.active]="!isEditingSectionField(DOCSTRING)"
                  nz-icon
                  nzType="sqtm-core-generic:delete"
                  nzTheme="outline"
                  (click)="deleteSection(DOCSTRING)"
                ></i>
              }
              <sqtm-core-editable-text-area-field
                #docstringTextArea
                [attr.data-test-field-id]="DOCSTRING"
                [value]="keywordStep.docstring"
                (cancelEvent)="handleCancelSection(DOCSTRING)"
                (confirmEvent)="changeSectionValue(DOCSTRING, $event)"
              >
              </sqtm-core-editable-text-area-field>
            </div>
          </div>
        }
        @if (displaySection(DOCSTRING) && displaySection(DATATABLE)) {
          <div class="datatable-and-docstring-warning step-section">
            <span
              class="sqtm-core-error-message"
              [attr.data-test-element-id]="'datatable-and-docstring-warning'"
            >
              {{
                'sqtm-core.test-case-workspace.test-steps.docstring-and-datatable-both-present.warning'
                  | translate
              }}
            </span>
          </div>
        }
        @if (displaySection(COMMENT)) {
          <div class="comment-section step-section">
            <div>
              <span class="header-color">{{
                'sqtm-core.entity.test-step.comment.label' | translate
              }}</span>
              @if (editable) {
                <i
                  class="m-l-5 sub-section-icon"
                  [attr.data-test-button-id]="'delete'"
                  [class.active]="!isEditingSectionField(COMMENT)"
                  nz-icon
                  nzType="sqtm-core-generic:delete"
                  nzTheme="outline"
                  (click)="deleteSection(COMMENT)"
                ></i>
              }
              <sqtm-core-editable-text-area-field
                #commentTextArea
                [attr.data-test-field-id]="COMMENT"
                [value]="keywordStep.comment"
                (cancelEvent)="handleCancelSection(COMMENT)"
                (confirmEvent)="changeSectionValue(COMMENT, $event)"
              >
              </sqtm-core-editable-text-area-field>
            </div>
          </div>
        }
      </div>
    }
  </div>
</div>

<nz-dropdown-menu #menu>
  <ul nz-menu [attr.data-test-menu-id]="'menu'">
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'create-datatable'"
      [nzDisabled]="
        hasOrIsEditingSection(DATATABLE) ||
        hasOrIsEditingSection(DOCSTRING) ||
        !editable
      "
      (click)="createSection(DATATABLE)"
    >
      {{
        'sqtm-core.test-case-workspace.test-steps.button.add-datatable'
          | translate
      }}
    </li>
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'create-docstring'"
      [nzDisabled]="
        hasOrIsEditingSection(DATATABLE) ||
        hasOrIsEditingSection(DOCSTRING) ||
        !editable
      "
      (click)="createSection(DOCSTRING)"
    >
      {{
        'sqtm-core.test-case-workspace.test-steps.button.add-docstring'
          | translate
      }}
    </li>
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'create-comment'"
      [nzDisabled]="hasOrIsEditingSection(COMMENT) || !editable"
      (click)="createSection(COMMENT)"
    >
      {{
        'sqtm-core.test-case-workspace.test-steps.button.add-comment'
          | translate
      }}
    </li>

    @if (autocompleteActive) {
      @if (keywordStep.canReadActionWord) {
        <li
          nz-menu-item
          style="text-decoration: none"
          class="hover-green"
          [attr.data-test-menu-item-id]="'navigate-to-action'"
          [nzDisabled]="!keywordStep.canReadActionWord"
          [sqtmCorePlatformLink]="[
            '/',
            'action-word-workspace',
            'action-word',
            'detail',
            keywordStep.actionWordLibraryNodeId.toString()
          ]"
        >
          {{
            'sqtm-core.test-case-workspace.test-steps.button.navigate-to-action'
              | translate
          }}
        </li>
      }
    } @else {
      <li
        nz-menu-item
        (click)="showAdvertisingDialog()"
        [attr.data-test-menu-item-id]="'navigate-to-action'"
      >
        <span>
          {{
            'sqtm-core.test-case-workspace.test-steps.button.navigate-to-action'
              | translate
          }}
        </span>
      </li>
    }
  </ul>
</nz-dropdown-menu>
